/*==========================================================================
 *
 *  Copyright (C) 1995 Microsoft Corporation. All Rights Reserved.
 *
 *  File:       ddutils.cpp
 *  Content:    Routines for loading bitmap and palettes from resources
 *
 ***************************************************************************/
#ifndef DDUTILINC
#define DDUTILINC

#include <ddraw.h>

IDirectDrawSurface * DDLoadBitmap(IDirectDraw *pdd, LPCSTR szBitmap, int dx, int dy, HINSTANCE module = NULL);
HRESULT              DDReLoadBitmap(IDirectDrawSurface *pdds, LPCSTR szBitmap, HINSTANCE module = NULL);
DWORD                DDColorMatch(IDirectDrawSurface *pdds, COLORREF rgb);
HRESULT              DDSetColorKey(IDirectDrawSurface *pdds, COLORREF rgb);
HRESULT					DDCopyBitmap(IDirectDrawSurface *pdds, HBITMAP hbm, int x, int y, int dx, int dy);

// uziti vlastnich nacitani - formanty
//IDirectDrawSurface * DDLoadBMP(IDirectDraw *pdd, LPCSTR szBitmap);
//IDirectDrawSurface * DDLoadPCX(IDirectDraw *pdd, LPCSTR szBitmap);
/*
IDirectDrawSurface * DDLoadRAW(IDirectDraw *pdd, LPCSTR szBitmap);
IDirectDrawSurface * DDLoadTGA(IDirectDraw *pdd, LPCSTR szBitmap);
IDirectDrawSurface * DDLoadGIF(IDirectDraw *pdd, LPCSTR szBitmap);
IDirectDrawSurface * DDLoadJPG(IDirectDraw *pdd, LPCSTR szBitmap);
*/
// pretizene pro inicializaci struktur
void					 	DDInitStruct(DDSURFACEDESC *structure);
void						DDInitStruct(DDPIXELFORMAT *structure);
void                 DDInitStruct(DDBLTFX *structure);

#endif