/*******************************************************************************/
//  Bernard Lidicky - 1999,2000
//  Hippo Games
//  Awary
//  Menu.cpp
/*******************************************************************************/

#include "stdafx.h"
#include "Awary.h"
#include "bbuttonek.h"
#include "Menu.h"

//******************************************************************************
CMMenu::CMMenu()
{
	m_bExit = new BButtonek;
	m_bExit->srect.SetRect(570,410,620,460);

	m_bAwCoVsHu = new BButtonek;
	m_bAwCoVsHu->srect.SetRect( 25,325,164,354);

	m_bAwHuVsCo = new BButtonek;
	m_bAwHuVsCo->srect.SetRect( 25,375,164,404);

	m_bAwHuVsHu = new BButtonek;
	m_bAwHuVsHu->srect.SetRect( 25,425,164,454);

	m_bOtCoVsHu = new BButtonek;
	m_bOtCoVsHu->srect.SetRect(470, 30,609, 59);

	m_bOtHuVsCo = new BButtonek;
	m_bOtHuVsCo->srect.SetRect(470, 80,609,109);

	m_bOtHuVsHu = new BButtonek;
	m_bOtHuVsHu->srect.SetRect(470,130,609,159);

	m_bLevelUp = new BButtonek;
	m_bLevelUp->srect.SetRect(290,170,310,200);

	m_bLevelDown = new BButtonek;
	m_bLevelDown->srect.SetRect(290,250,310,280);

	

	lpDDSMenu = NULL;
	lpDDSMenu = DDLoadBitmap(ddraw,"IDB_MENU",0,0,AfxGetApp()->m_hInstance); 
	if (lpDDSMenu == NULL) AfxGetApp()->m_pMainWnd->SendMessage(WM_QUIT);
	DDSetColorKey(lpDDSMenu, RGB(255,0,255));

	m_font.CreateFont(20,0,0,0,FW_BOLD,0,0,0,1,OUT_DEFAULT_PRECIS, 
						   CLIP_DEFAULT_PRECIS,PROOF_QUALITY,DEFAULT_PITCH,
							"Times New Roman"); // Verdena - Times New Roman

	m_level = 1;


}
//******************************************************************************
CMMenu::~CMMenu()
{
	delete m_bExit; // konec hry
	delete m_bAwCoVsHu;
	delete m_bAwHuVsCo;
	delete m_bAwHuVsHu;

	delete m_bOtCoVsHu;
	delete m_bOtHuVsCo;
	delete m_bOtHuVsHu;

	delete m_bLevelUp;
	delete m_bLevelDown;

	if(lpDDSMenu != NULL)
		lpDDSMenu->Release();
}
//******************************************************************************
BOOL CMMenu::OnTimer()
{
	HRESULT hres;

	// vlozeni pozadi
	hres = ddraw.m_lpDDSBack->BltFast(0,0,lpDDSMenu,&CRect(0,0,640,480),DDBLTFAST_NOCOLORKEY | DDBLTFAST_WAIT);
	if(hres == DDERR_SURFACELOST) {
		Restore();
	}


/* buttonky se neprekresluji - jsou natvrdo na obrazovce
	m_bExit->RedrawButton(ddraw.m_lpDDSBack,lpDDSMenu);
*/
	ddraw.m_lpDDSBack->BltFast(m_bAwCoVsHu->srect.left,m_bAwCoVsHu->srect.top,lpDDSMenu,&m_bAwCoVsHu->menubmp,DDBLTFAST_SRCCOLORKEY | DDBLTFAST_WAIT);
	ddraw.m_lpDDSBack->BltFast(m_bAwHuVsCo->srect.left,m_bAwHuVsCo->srect.top,lpDDSMenu,&m_bAwHuVsCo->menubmp,DDBLTFAST_SRCCOLORKEY | DDBLTFAST_WAIT);
	ddraw.m_lpDDSBack->BltFast(m_bAwHuVsHu->srect.left,m_bAwHuVsHu->srect.top,lpDDSMenu,&m_bAwHuVsHu->menubmp,DDBLTFAST_SRCCOLORKEY | DDBLTFAST_WAIT);

	ddraw.m_lpDDSBack->BltFast(m_bOtCoVsHu->srect.left,m_bOtCoVsHu->srect.top,lpDDSMenu,&m_bOtCoVsHu->menubmp,DDBLTFAST_SRCCOLORKEY | DDBLTFAST_WAIT);
	ddraw.m_lpDDSBack->BltFast(m_bOtHuVsCo->srect.left,m_bOtHuVsCo->srect.top,lpDDSMenu,&m_bOtHuVsCo->menubmp,DDBLTFAST_SRCCOLORKEY | DDBLTFAST_WAIT);
	ddraw.m_lpDDSBack->BltFast(m_bOtHuVsHu->srect.left,m_bOtHuVsHu->srect.top,lpDDSMenu,&m_bOtHuVsHu->menubmp,DDBLTFAST_SRCCOLORKEY | DDBLTFAST_WAIT);

	ddraw.m_lpDDSBack->BltFast(290,210,lpDDSMenu,&CRect((m_level-1)*30,698,m_level*30,728),DDBLTFAST_SRCCOLORKEY | DDBLTFAST_WAIT);

	return TRUE;
}
//******************************************************************************
void CMMenu::OnMouseMove(CPoint point)
{
	m_bExit->MouseMove(point);
	m_bAwCoVsHu->MouseMove(point);
	m_bAwHuVsCo->MouseMove(point);
	m_bAwHuVsHu->MouseMove(point);
	m_bOtCoVsHu->MouseMove(point);
	m_bOtHuVsCo->MouseMove(point);
	m_bOtHuVsHu->MouseMove(point);
	m_bLevelDown->MouseMove(point);
	m_bLevelUp->MouseMove(point);
}
//******************************************************************************
void CMMenu::OnLButtonDown(CPoint point)
{
	m_bExit->MouseLBDn(point);
	m_bAwCoVsHu->MouseLBDn(point);
	m_bAwHuVsCo->MouseLBDn(point);
	m_bAwHuVsHu->MouseLBDn(point);
	m_bOtCoVsHu->MouseLBDn(point);
	m_bOtHuVsCo->MouseLBDn(point);
	m_bOtHuVsHu->MouseLBDn(point);
	m_bLevelDown->MouseLBDn(point);
	m_bLevelUp->MouseLBDn(point);
}
//******************************************************************************
void CMMenu::OnLButtonUp(CPoint point)
{

	if(m_bExit->MouseLBUp(point))
		AfxGetApp()->m_pMainWnd->PostMessage(WM_CLOSE);

	if(m_bAwCoVsHu->MouseLBUp(point)) {
		m_pHraA->NovaHra(m_level,CLOVEK,HRAC_DOLE,0);
		AfxGetApp()->m_pMainWnd->PostMessage(WM_HRA,AWARY);
		return;
	}

	if(m_bAwHuVsCo->MouseLBUp(point)) {
		m_pHraA->NovaHra(CLOVEK,m_level,HRAC_DOLE,0);
		AfxGetApp()->m_pMainWnd->PostMessage(WM_HRA,AWARY);
		return;
	}

	if(m_bAwHuVsHu->MouseLBUp(point)) {
		m_pHraA->NovaHra(CLOVEK,CLOVEK,HRAC_DOLE,0);
		AfxGetApp()->m_pMainWnd->PostMessage(WM_HRA,AWARY);
		return;
	}

	if(m_bOtCoVsHu->MouseLBUp(point)) {
		m_pHraO->NovaHra(m_level,CLOVEK,HRAC_BILY,0);
		AfxGetApp()->m_pMainWnd->PostMessage(WM_HRA,OTHELLO);
		return;
	}

	if(m_bOtHuVsCo->MouseLBUp(point)) {
		m_pHraO->NovaHra(CLOVEK,m_level,HRAC_BILY,0);
		AfxGetApp()->m_pMainWnd->PostMessage(WM_HRA,OTHELLO);
		return;
	}

	if(m_bOtHuVsHu->MouseLBUp(point)) {
		m_pHraO->NovaHra(CLOVEK,CLOVEK,HRAC_BILY,0);
		AfxGetApp()->m_pMainWnd->PostMessage(WM_HRA,OTHELLO);
		return;
	}

	if(m_bLevelUp->MouseLBUp(point)) 
		if(m_level < 6) m_level++;

	if(m_bLevelDown->MouseLBUp(point)) 
		if(m_level > 1) m_level--;

	// resetovani knofliku
	m_bExit->stav_old = m_bExit->stav = 0;
	m_bAwCoVsHu->stav_old = m_bAwCoVsHu->stav = 0;
	m_bAwHuVsCo->stav_old = m_bAwHuVsCo->stav = 0;
	m_bAwHuVsHu->stav_old = m_bAwHuVsHu->stav = 0;
	m_bOtCoVsHu->stav_old = m_bOtCoVsHu->stav = 0;
	m_bOtHuVsCo->stav_old = m_bOtHuVsCo->stav = 0;
	m_bOtHuVsHu->stav_old = m_bOtHuVsHu->stav = 0;
	m_bLevelUp->stav_old = m_bLevelUp->stav = 0;
	m_bLevelDown->stav_old = m_bLevelDown->stav = 0;

	UpdateButtonsType();
}
//******************************************************************************
void CMMenu::Activate(CHraAwary *p_hraA, CHraOthello *p_hraO)
{
	m_pHraA = p_hraA;
	m_pHraO = p_hraO;

	ZobrazKurzor(TRUE);

	// reset buttonku
	m_bExit->stav_old = m_bExit->stav = 0;
	m_bAwCoVsHu->stav_old = m_bAwCoVsHu->stav = 0;
	m_bAwHuVsCo->stav_old = m_bAwHuVsCo->stav = 0;
	m_bAwHuVsHu->stav_old = m_bAwHuVsHu->stav = 0;
	m_bOtCoVsHu->stav_old = m_bOtCoVsHu->stav = 0;
	m_bOtHuVsCo->stav_old = m_bOtHuVsCo->stav = 0;
	m_bOtHuVsHu->stav_old = m_bOtHuVsHu->stav = 0;

	m_bLevelUp->stav_old = m_bLevelUp->stav = 0;
	m_bLevelDown->stav_old = m_bLevelDown->stav = 0;

	UpdateButtonsType();
}
//******************************************************************************
void CMMenu::OnKeyDown(UINT nChar)
{
	switch (nChar) {
	case VK_ESCAPE :
		AfxGetApp()->m_pMainWnd->PostMessage(WM_CLOSE);
		break;
	}
}
//******************************************************************************
void CMMenu::Restore()
{
	lpDDSMenu->Restore();
	DDReLoadBitmap(lpDDSMenu,"IDB_MENU",AfxGetApp()->m_hInstance);
}
//******************************************************************************
void CMMenu::UpdateButtonsType()
{
	if(A_CPVSPL(m_pHraA->m_level[m_level-1])) m_bAwCoVsHu->menubmp.SetRect(  0,482,140,511);
	else  m_bAwCoVsHu->menubmp.SetRect(  0,512,140,542);
	if(A_PLVSCP(m_pHraA->m_level[m_level-1]))	m_bAwHuVsCo->menubmp.SetRect(  0,543,140,573);
	else m_bAwHuVsCo->menubmp.SetRect(  0,574,140,604);
	m_bAwHuVsHu->menubmp.SetRect(  0,605,140,635);

	if(O_CPVSPL(m_pHraO->m_level[m_level-1])) m_bOtCoVsHu->menubmp.SetRect( 141,482,280,511);
	else  m_bOtCoVsHu->menubmp.SetRect(  141,512,280,542);
	if(O_PLVSCP(m_pHraO->m_level[m_level-1]))	m_bOtHuVsCo->menubmp.SetRect( 141,543,280,573);
	else m_bOtHuVsCo->menubmp.SetRect( 141,574,280,604);
	m_bOtHuVsHu->menubmp.SetRect( 141,605,280,635);

	m_bLevelUp->menubmp.SetRect(   0,636,30,666);
	m_bLevelDown->menubmp.SetRect( 0,667,30,697);

}

