/*******************************************************************************/
//  Bernard Lidicky - 1999, 2000
//  CHraAwary class - Include
/*******************************************************************************/
// definuje hraci prostredi

#if !defined(AFX_HRA_H__5B2CB4C0_4197_11D3_8F74_83A671FF75B3__INCLUDED_)
#define AFX_HRA_H__5B2CB4C0_4197_11D3_8F74_83A671FF75B3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


// urcuje m_hrac[..]
#define HRAC_DOLE   0
#define HRAC_NAHORE 1

// kdo je co  m_tahne, m_hrac[2]
#define CLOVEK  0
//dalsi cisla jsou cisla obtiznosti 

#define MAX_ANIM  5

// o hraci - jak je na tom
#define A_CPDONE(x)  ((x) |= 0x00000001)
#define A_PLDONE(x)  ((x) |= 0x00000002)
#define A_CPVSPL(x)  ((x) &  0x00000001)
#define A_PLVSCP(x)  ((x) &  0x00000002)

class CHraAwary : public Base 
{
public:
	void Refresh();
	void UnlockBuffers();
	void LockBuffers();
	void DalsiTah();
	void Activate(); // oznamuje, ze se hra stala aktivni
	CHraAwary();          // konstruktor
	virtual ~CHraAwary(); // destrukktor
	BOOL Draw();     // vykresli aktualinni stav do back surface
	bool Konec(); // vrati, zda nekdo vyhral
	void NovaHra(int pl1, int pl2, int zacina, int pozadi); // inicializuje novou hru
	void OnKeyDown(UINT nChar);       // uzivatel neco stiskl
	void OnLButtonDown(CPoint point); // zprava mysi
	void OnLButtonUp(CPoint point);   // zprava mysi
	void OnMouseMove(CPoint point);   // zprava mysi
	BOOL OnTimer();  // odezva hlavniho timeru ( 40 ms )
	void Restore();  // pri ztrate surfacu
	void Tahnul(int x, int kdo); // kam tahnul nas hrac ?

	void Done();
	// bitmapy
	LPDIRECTDRAWSURFACE     m_lpDDSAll;      // pozadi

	LPDIRECTDRAWSURFACE     m_lpDDSKameny;    // hraci kameny
	
	CFont m_font;  // hlavni font
	CWinThread *m_thread; // drzime si ukazatel
	int   m_t1; // stratovni cas jednoho tahu

	int    m_toredraw;
	CPoint m_plr;  // mys hrace 
 
	int  m_tah;    // cilso tahu
	int  m_tahne;     //  0 / 1 (HRAC_DOLE / HRAC_NAHORE,...)  
	int  m_hrac[2];  // kdo hraje // obtiznost
	int  m_cas[2];    // jak dlouho
	int  m_rand;

	int m_mousep;  // na ktere policko hrac ukazuje (zobrazuje se pocet kamenu na danem policku) 

	int  m_zacinal;  // indikator , kdo zacinal

	// awary
	int  m_hra[15];     // plocha hry
	int  m_draw[15][36]; // plocha hry na kresleni - pocita s animaci

	int  m_level[6];  // maximalni level dosazeny v awarech



private:
	void TestNextLevel();
};

// threads communications
extern bool t_kill;
extern bool t_hotovo;
extern bool t_running;


#endif // !defined(AFX_HRA_H__5B2CB4C0_4197_11D3_8F74_83A671FF75B3__INCLUDED_)
