/*******************************************************************************/
//  Bernard Lidicky - 1999,2000
//  CMainFrame class - Include
/*******************************************************************************/

#if !defined(AWARY_MAINFRM_H)
#define AWARY_MAINFRM_H

#include "base.h"
#include "HraAwary.h"
#include "HraOthello.h"
#include "Menu.h"

class CMainFrame : public CFrameWnd
{
	
public:
	CMainFrame();

protected: 
	DECLARE_DYNAMIC(CMainFrame)

	CHraAwary   *m_hraAwary;
	CHraOthello *m_hraOthello;

   CMMenu *m_menu;

	int	 m_uTimerID;

	Base	*m_pactual;

	HICON   m_icon;
	HCURSOR m_cursor;

public:
	void WmRestore(int parama, int paramb);
	void WmHra(int parama, int paramb);
	void WmMenu(int parama, int paramb);

	void Init(int parama, int paramb);
	BOOL RestoreAll();
	virtual ~CMainFrame();

protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg void OnPaint();
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnClose();
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // #if !defined(AWARY_MAINFRM_H)

