// Hippo Direct Draw Class
// pokud vam nejaka cast nevyhovuje, muzete si ji sami upravit k obrazu svemu

#ifndef HDDRAW_HEADER
#define HDDRAW_HEADER

// using  640*480* !16!

#define DIRECTDRAW_VERSION  0x0300       /* version 3.0 pro NT*/
#include <ddraw.h> // pro jistotu

#include "ddutils.h"

// using DirectDraw 5  - nemam doma DX7.00 - dll knihovny
class HDDraw
{
public:
	HDDraw();
	HDDraw(HWND hWnd, DWORD Width, DWORD Height, DWORD BPP = 16, DWORD Color = 0);
	~HDDraw();

public:

	// operatory
	operator LPDIRECTDRAW();

	BOOL CreateFullScreen(HWND hWnd, DWORD Width, DWORD Height,  DWORD BPP = 16,DWORD FillColor = 0);

	void Fill   (DWORD FillColor);
	void FillGDI(DWORD FillColor);

	void Restore();

	HRESULT Flip(BOOL VSync=TRUE);


	void InitHDDraw();


public:
	LPDIRECTDRAWSURFACE CreateSurface(DWORD dwWidth, DWORD dwHeight);
	void ReleaseBackDC();
	HDC GetBackDC();
	HRESULT FlipToGDI();

	LPDIRECTDRAW m_lpDD;   // hlavni objekt
	LPDIRECTDRAWSURFACE m_lpDDSGDI;
	LPDIRECTDRAWSURFACE m_lpDDSBack;


	HDC  m_dcBack;

	BOOL m_bFullScreen; // je ve FullScreen modu ? 						
	BOOL m_GDIVisible;  // zda je zobrazen GDI surface
	BOOL m_FlipLock;    // zakazeflipping - misto toho se pouziva jednoduse kopirovani

	RECT m_Rect;  // ma v sobe rozmery obrazovky
};

#endif
